<?php

namespace Ulmus\User\Middleware;

use Psr\Http\{
    Message\ResponseInterface,
    Message\ServerRequestInterface,
    Server\MiddlewareInterface,
    Server\RequestHandlerInterface
};
use Ulmus\User\Authorize\AuthorizeMethodInterface;
use Ulmus\User\Common\AuthorizeEnum;

class AuthorizeMiddleware implements MiddlewareInterface
{
    public function __construct(
        protected AuthorizeMethodInterface $method,
        protected ResponseInterface $loginFailed,
    ) { }

    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        if ( false ) {
            return $this->loginFailed;
        }

        return $handler->handle($request);
    }
}
